package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.gfx.*;
import com.danitheskunk.skunkworks.gfx.font.IFont;

import java.util.List;

public interface IWindow {
	Engine getEngine();

	IFont loadFontTileset(String path);

	IFont loadFontTTF(String path, float size);

	NineSlice loadNineSlice(Image image);

	NineSlice loadNineSlice(String path);

	ITexture loadTexture(Image image);

	ITexture loadTexture(String path);

	List<ITexture> loadTextureArray(Image image, Vec2i tileSize);

	List<ITexture> loadTextureArray(String path, Vec2i tileSize);

	void renderFinish(IRenderContext context);

	IRenderContext renderStart();

	void renderFinish3D(IRenderContext3D context);

	IRenderContext3D renderStart3D();

	//needs to be run after rendering
	void runScaler();

	void setDebug(boolean on);

	boolean shouldClose();

	void setStretchMode(WindowStretchMode mode);

	Vec2i getMousePos();

	boolean isMouseClicked(int button);

	boolean isMouseDown(int button);

	void tick();
}
